unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Grids, ValEdit, ObjInspect, StdCtrls, Buttons, DefRegister, TypInfo,
  KclTransUtils;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    ObjInspector: TKclObjInspector;
    CheckBoxTrans: TCheckBox;
    GroupBox1: TGroupBox;
    ListBoxSelCtrls: TListBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Memo1: TMemo;
    CheckBox1: TCheckBox;
    RadioButton1: TRadioButton;
    ScrollBar1: TScrollBar;
    SpeedButton1: TSpeedButton;
    BitBtn1: TBitBtn;
    Image1: TImage;
    Shape1: TShape;
    Bevel1: TBevel;
    Timer1: TTimer;
    EditSelComps: TEdit;
    BitBtnHelp: TBitBtn;
    Label3: TLabel;
    procedure FormShow(Sender: TObject);
    procedure ListBoxSelCtrlsClick(Sender: TObject);
    procedure ObjInspectorChangeActiveComponent(Sender: TObject);
    procedure CheckBoxTransClick(Sender: TObject);
    procedure ObjInspectorTranslateIdent(Sender: TObject; PTI: PTypeInfo;
      Src: String; TransRole: TTransRole; var Dest: String);
    procedure ObjInspectorTranslateToIdent(Sender: TObject; PTI: PTypeInfo;
      Src: String; TransRole: TTransRole; var Dest: String);
    procedure BitBtnHelpClick(Sender: TObject);
  private
    { Private declarations }
    procedure FillAvailableComps;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.dfm}

{ TForm1 }

procedure TForm1.FillAvailableComps;
var
  I: Integer;
  C: TComponent;
  CN: string;
begin
  for I := 0 to Self.ComponentCount - 1 do
  begin
    C := Self.Components[I];
    if C <> ObjInspector then
    begin
      if Trim(C.Name) = '' then
        CN := '[NoName]'
      else
        CN := C.Name;
      ListBoxSelCtrls.Items.AddObject(CN, C);
    end;
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  FillAvailableComps;
  ObjInspector.ActiveComponent := Self;
end;


procedure TForm1.ListBoxSelCtrlsClick(Sender: TObject);
var
  I: Integer;
  C: TComponent;
begin

  ObjInspector.ActiveComponent := nil;   // Clear origin selection
  for I := 0 to ListBoxSelCtrls.Items.Count - 1 do
  begin
    if ListBoxSelCtrls.Selected[I] then
    begin
      C := TComponent(ListBoxSelCtrls.Items.Objects[I]);
      ObjInspector.AddActiveComponent(C);
    end;
  end;

  ObjInspector.Refresh;
end;

procedure TForm1.ObjInspectorChangeActiveComponent(Sender: TObject);
begin
  if ObjInspector.ActiveComponents.Count = 1 then
    EditSelComps.Text := ObjInspector.ActiveComponent.Name
  else
    EditSelComps.Text := IntToStr(ObjInspector.ActiveComponents.Count) + ' Items selected';
end;

procedure TForm1.CheckBoxTransClick(Sender: TObject);
begin
  ObjInspector.Translate := CheckBoxTrans.Checked;
end;

procedure TForm1.ObjInspectorTranslateIdent(Sender: TObject;
  PTI: PTypeInfo; Src: String; TransRole: TTransRole; var Dest: String);
begin
  if SameText(Src, 'True') then
    Dest := '[YES]'
  else if SameText(Src, 'False') then
    Dest := '[NO]'
  else if SameText(Src, 'Align') then
    Dest := '[ALIGN]';
end;

procedure TForm1.ObjInspectorTranslateToIdent(Sender: TObject;
  PTI: PTypeInfo; Src: String; TransRole: TTransRole; var Dest: String);
begin
  if SameText(Src, '[YES]') then
    Dest := 'True'
  else if SameText(Src, '[NO]') then
    Dest := 'False'
  else if SameText(Src, '[ALIGN]') then
    Dest := 'Align';
end;

procedure TForm1.BitBtnHelpClick(Sender: TObject);
begin
  FormReadme.Show;
end;

initialization
  DefRegister.RegisterPropEditors;
  DefRegister.RegisterComponentEditors;
  DefRegister.RegisterAttribEditors;
end.
